#-*- coding:utf-8 -*-

from System import *
from System.ComponentModel import *
from pyevent import *

class SeeMeSetting():
    def __init__(self):
        self.version = 1
        self.left = -1
        self.top = -1
        self.width = 500
        self.height = 500
        self.default_path = ""
        self.custome_path = ""
        self.prefs_path = ""
        self.lang_path = ""
        self.default_path2 = ""
        self.custome_path2 = ""
        self.prefs_path2 = ""
        self.lang_path2 = ""
        self.texteditor = ""
        self.verbtext = 0

class NotifyPropertyChangedBase(INotifyPropertyChanged):
    """
        http://sdlsdk.codeplex.com/Thread/View.aspx?ThreadId=30322
    """
    PropertyChanged = None
    def __init__(self):
        (self.PropertyChanged, self._propertyChangedCaller) = make_event()

    def add_PropertyChanged(self, value):
        self.PropertyChanged += value

    def remove_PropertyChanged(self, value):
        self.PropertyChanged -= value
    
    def OnPropertyChanged(self, propertyName):
        self._propertyChangedCaller(self, PropertyChangedEventArgs(propertyName))

class Engine(NotifyPropertyChangedBase):
    """
        use setter getter.
        IronPython 2.6 or later.
    """
    @property
    def name(self):
        return self._name

    @name.setter
    def name(self, value):
        self._name = value
        self.OnPropertyChanged("name")

    @property
    def delete(self):
        return self._delete

    @delete.setter
    def delete(self, value):
        self._delete = value
        self.OnPropertyChanged("delete")

    @property
    def key(self):
        return self._key

    @key.setter
    def key(self, value):
        self._key = value
        self.OnPropertyChanged("key")

    @property
    def url(self):
        return self._url

    @url.setter
    def url(self, value):
        self._url = value
        self.OnPropertyChanged("url")

    @property
    def query(self):
        return self._query

    @query.setter
    def query(self, value):
        self._query = value
        self.OnPropertyChanged("query")

    @property
    def post(self):
        return self._post

    @post.setter
    def post(self, value):
        self._post = value
        self.OnPropertyChanged("post")

    @property
    def endsep(self):
        return self._endsep

    @endsep.setter
    def endsep(self, value):
        self._endsep = value
        self.OnPropertyChanged("endsep")

    @property
    def encode(self):
        return self._encode

    @encode.setter
    def encode(self, value):
        self._encode = value
        self.OnPropertyChanged("encode")

    @property
    def type(self):
        return self._type

    @type.setter
    def type(self, value):
        self._type = value
        self.OnPropertyChanged("type")

    @property
    def pos(self):
        return self._pos

    @pos.setter
    def pos(self, value):
        self._pos = value
        self.OnPropertyChanged("pos")

    @property
    def nameid(self):
        return self._nameid

    @nameid.setter
    def nameid(self, value):
        self._nameid = value
        self.OnPropertyChanged("nameid")

    @property
    def verb(self):
        return self._verb

    @verb.setter
    def verb(self, value):
        self._verb = value
        self.OnPropertyChanged("verb")

    @property
    def icon(self):
        return self._icon

    @icon.setter
    def icon(self, value):
        self._icon = value
        self.OnPropertyChanged("icon")

    @property
    def unique(self):
        return self._unique

    @unique.setter
    def unique(self, value):
        self._unique = value
        self.OnPropertyChanged("unique")

    @property
    def usetld(self):
        return self._usetld

    @usetld.setter
    def usetld(self, value):
        self._usetld = value
        self.OnPropertyChanged("usetld")